// Copyright (C) 1999 Joshua Fox

package ddj;

import com.sun.media.jsdt.ChannelConsumer;
import com.sun.media.jsdt.Data;

class ChatConsumer implements ChannelConsumer {

    /**
     * Shows messages that we receive.
     */
    private ChatApplicationGUI  gui;

    /**
     *
     */
    public ChatConsumer(ChatApplicationGUI  chatGui ) {
        gui = chatGui;
    }


    /**
     *  The call-back method. We receive data from the JSDT
     * as the parameter in this method.
     */
    synchronized public void dataReceived(Data data) {
        // A note about Data: Among the fields of the data object is the
        // priority, accessible with data.getPriority(). The priorities
        // are ignored in the current JSDT implementation.

        String sender = data.getSenderName();

        // The Data object carries an internal byte[].
        // You can use this byte array to carry a String
        // or object, or just as a byte array.
        String msg = data.getDataAsString();

        gui.receiveMessage("Session " + data.getChannel().getSession().getName() +
                ": Sender " + sender + "->" + msg + "\n");
    }
}
