// Copyright (C) 1999 Joshua Fox
package ddj;

import java.awt.*;
import java.awt.event.*;

/**
* This GUI, like the client-side ChatApplicationGUI, is
* designed for modularity: it has no references to the JSDT.
*/
class ChatServerGUI extends Frame  {
    private List list;
    DDJChatServer chatServer;
    Panel controlPanel = new Panel();
    Button addSessionButton = new Button();
    TextField addSessionTextField = new TextField();

    /**
     * The Constructor initializes the GUI elements and
     * starts the Thread.
     */
    public ChatServerGUI(DDJChatServer server) {
        super("Chat Server");
        chatServer = server;        
        initialize();
    }


    /**
     *
     */
    private void initialize() {

        this.setSize(400,600);
        this.setLocation(600,50);

        controlPanel.setLayout(new BorderLayout());
        controlPanel.setBackground(Color.yellow);

        addSessionButton.setLabel("Add Session:");
        addSessionButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                chatServer.startSessionIfNeeded(addSessionTextField.getText());
            }
        });

        addSessionTextField.setBackground(Color.white);
        addSessionTextField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event){
                 chatServer.startSessionIfNeeded(addSessionTextField.getText());
            }
        });



        controlPanel.add(addSessionButton, BorderLayout.WEST);
        controlPanel.add(addSessionTextField, BorderLayout.CENTER);

        list = new List(30, false);
        list.setBackground(Color.yellow);

        this.add(list, BorderLayout.CENTER);
        this.add(controlPanel, BorderLayout.NORTH);

        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent ev) {
                chatServer.stopServer();
                System.exit(0);
            }
        });

        this.setVisible(true);
    }

    /**
     * Add an item to the List.
     */
    void addSession(String sessionUrl) {
        list.addItem(sessionUrl);
    }
}
