// Copyright (C) 1999 Joshua Fox
package ddj;

/**
 * A holder for various Constants that have to be shared by
 * components of the JSDT system.
 */
public interface Constants {
    /**
     * The port for Sessions. Note that alongside this port,
     * another port is needed for the Registry. The Registry
     * port is 4561 by default.  To change the Registry port,
     * just set com.sun.media.jsdt.impl.JSDTObject.registryPort
     * to the desired value.
     * (See the JSDT user guide for this and other parameters
     * you can set, like timeout period and debugging output.
     */
    public static final int SESSION_PORT = 4871;


    /**
     * Other JSDT "implementations" (transport layers)
     * include "http" and "lrmp".
     */
    public static final String JSDT_IMPLEMENTATION = "socket";


    /**
     * The name of the Channel over which the participants chat.
     * Here we have only one Channel in the Session.
     * We might have more Channels, for example, in a chess system:
     * One Channel for discussion between the players and another
     * Channel (or even a ByteArray) for the chess moves.
     */
    public static final String CHAT_CHANNEL_NAME = "chat";
}
