#include <stdio.h>
#include "interp.h"
// ----- intrinsic functions
int iprntf(int* p)           //   printf   
{
    printf(reinterpret_cast<char*>(p[0]),p[1],p[2],p[3],p[4]);
    return 0;
}
int igtch()					//  getchar
{
    return getchar();
}
int iptch(int* c)			//  putchar   
{
    return putchar(*c);
}
char* getver()				// return a string
{
	return "Version 1.0";
}
Intrinsic funcs[] = {
	Intrinsic("int printf",	      reinterpret_cast<ifunc>(iprntf)),
	Intrinsic("int getchar",      reinterpret_cast<ifunc>(igtch) ),
	Intrinsic("int putchar",   	  reinterpret_cast<ifunc>(iptch) ),
	Intrinsic("string getversion",reinterpret_cast<ifunc>(getver)),
	Intrinsic("",        0)
};
// ---------- error messages 
char *erm[]={  "Unexpected end of file", "Unrecognized",
               "Duplicate ident",        "Undeclared ident",
               "Syntax Error",           "Unmatched {}",
               "Unmatched ()",           "Missing",
               "Not a function",         "Misplaced break",
               "Out of place",           "Not an identifer",
               "Mismatched arguments",   "Divide by zero",
			   "Invalid constant",		 "No main function"
};
static FILE *fp;
int main(int argc, char *argv[])
{
    if (argc == 2)	{
        if ((fp = fopen(argv[1], "r")) != 0) {
			try	{
				SInterpreter si(funcs);
				si.interpret();
			}
			catch (SIException sex)	{
			    printf("\n%s %s on line %d\n",erm[sex.ercode], 
							sex.msg.c_str(), sex.lineno);
			}
            fclose(fp);
        }
	}
	return 0;
}
// ----- functions that the interpreter requires
int getsource(void)     {   return getc(fp);    }
void ungetsource(int c) {   ungetc(c, fp);      }
